#!/v/guest/sw/bin/perl -w

###############################################################################
##                                                                           ##
##    Copyright (c) 2007 - 2010 by Steffen Beyer.                            ##
##    All rights reserved.                                                   ##
##                                                                           ##
##    This program is free software; you can redistribute it                 ##
##    and/or modify it under the same terms as Perl itself.                  ##
##                                                                           ##
###############################################################################

use strict;

use lib
qw(
    /u/sb/sw/pkg/perl/lib/perl/5.10.1/amd64-freebsd
    /u/sb/sw/pkg/perl/lib/perl/5.10.1
    /u/sb/sw/pkg/perl/lib/perl/site_perl/5.10.1/amd64-freebsd
    /u/sb/sw/pkg/perl/lib/perl/site_perl/5.10.1
);

use Date::Calc qw(Language_to_Text Decode_Language);
use Fcntl qw(:flock);

umask(022);

my($Title)   = 'EPO Volleyball Club Member List Administration';
my($Conf)    = 'members.txt';
my($Dots)    = '...';
my($Time)    = time();
my($Lang)    = 1;
my($Save)    = 0;
my($Person)  = '';
my($Command) = '';
my($Timeout) = 0;
my($Updated) = 0;
my(@Members) = ($Dots);
my(@Text)    = ();
my(@html)    = ();
my(@lang)    = ();

my($m,$n,$p);

$Text[0][1] = "Please select your preferred language:";
$Text[0][2] = "S.v.p. s&eacute;lectionnez votre langue pr&eacute;f&eacute;r&eacute;e:";
$Text[0][3] = "Bitte w&auml;hlen Sie Ihre bevorzugte Sprache:";
$Text[0][4] = "Por favor seleccione su idioma preferido:";
$Text[0][5] = "Por favor selecione sua l&iacute;ngua preferida:";
$Text[0][6] = "U meest gewenste taal kiezen a.u.b.:";

$Text[1][1] = "Update";
$Text[1][2] = "Actualiser";
$Text[1][3] = "Aktualisieren";
$Text[1][4] = "Actualizar";
$Text[1][5] = "Atualizar";
$Text[1][6] = "Aktualiseeren";

$Text[2][1] = "There are no frequent players yet.";
$Text[2][2] = "Il n'y a pas encore de joueurs fr&eacute;quents.";
$Text[2][3] = "Es gibt noch keine h&auml;ufigen Mitspieler.";
$Text[2][4] = "Todavia no hay jugadores frecuentes.";
$Text[2][5] = "Ainda n&atilde;o tem jogadores freq&uuml;entes.";
$Text[2][6] = "Er zijn nog geen vaake medespelers.";

$Text[3][1] = "There is one frequent player:";
$Text[3][2] = "Il y a un joueur fr&eacute;quent:";
$Text[3][3] = "Es gibt einen h&auml;ufigen Mitspieler:";
$Text[3][4] = "Hay un jugador frecuente:";
$Text[3][5] = "Tem um jogador freq&uuml;ente:";
$Text[3][6] = "Er is een vaake medespeler:";

$Text[4][1] = "There are # frequent players:";
$Text[4][2] = "Il y a # joueurs fr&eacute;quents:";
$Text[4][3] = "Es gibt # h&auml;ufige Mitspieler:";
$Text[4][4] = "Hay # jugadores frecuentes:";
$Text[4][5] = "Tem # jogadores freq&uuml;entes:";
$Text[4][6] = "Er zijn # vaake medespelers:";

$Text[5][1] = "Remove this frequent player";
$Text[5][2] = "Retirer ce joueur fr&eacute;quent";
$Text[5][3] = "Diesen h&auml;ufigen Mitspieler entfernen";
$Text[5][4] = "Quitar este jugador frecuente";
$Text[5][5] = "Tirar este jogador freq&uuml;ente";
$Text[5][6] = "Deze vaake medespeler verwijderen";

$Text[6][1] = "Add frequent player";
$Text[6][2] = "Ajouter joueur fr&eacute;quent";
$Text[6][3] = "H&auml;ufigen Mitspieler hinzuf&uuml;gen";
$Text[6][4] = "Adicionar jugador frecuente";
$Text[6][5] = "Acrescentar jogador freq&uuml;ente";
$Text[6][6] = "Vaake medespeler toevoegen";

eval
{
    if (-e $Conf) { open(CONF, "+<$Conf") or die; }
    else          { open(CONF, "+>$Conf") or die; }
    flock(CONF, LOCK_EX) or die;
    $Updated = (stat(CONF))[9]||0;
    seek(CONF, 0, 0) or die;
    @Members = sort grep { !/^\.*$/ } map { my($x) = $_; $x =~ s/^\s+//; $x =~ s/\s+$//; $x =~ s/\#.*$//; $x } <CONF>;
    unshift(@Members, $Dots);
};

if ($@) { @Members = ($Dots); $Updated = 0; }

init_tables();
process_query_string();
execute_command();

eval
{
    if ($Save) # if a command was executed, data structure must be stored
    {
        truncate(CONF, 0) or die;
        seek(CONF, 0, 0) or die;
        print CONF map "$_\n", @Members;
    }
    flock(CONF, LOCK_UN) or die;
    close(CONF) or die;
};

print <<"VERBATIM";
Content-type: text/html; charset="iso-8859-1"

<HTML>
<HEAD>
    <META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
    <TITLE>$Title</TITLE>
</HEAD>
<BODY>
<CENTER>
    <P>
    <HR NOSHADE SIZE="2">
    <P>
    <H1>$Title</H1>
    <P>
    <HR NOSHADE SIZE="2">
    <P>
    <TABLE BGCOLOR="#F4F4F4" CELLSPACING="1" CELLPADDING="7" BORDER="2"><TR><TD>
    <FORM METHOD="GET" ACTION="">
    <TABLE BGCOLOR="#F4F4F4" CELLSPACING="1" CELLPADDING="7" BORDER="0">
    <TR>
    <TD>$Text[0][$Lang]</TD>
    <TD>
    <SELECT NAME="l">
VERBATIM
for ( $n = 1; $n <= 6; $n++ )
{
    if ($n == $Lang) { print qq(    <OPTION VALUE="$n" SELECTED>$n - $lang[$n]</OPTION>\n); }
    else             { print qq(    <OPTION VALUE="$n">$n - $lang[$n]</OPTION>\n); }
}
print <<"VERBATIM";
    </SELECT>
    </TD>
    <TD>
    <INPUT TYPE="submit" VALUE="$Text[1][$Lang]">
    </TD>
    </TR>
    </TABLE>
    </FORM>
    </TD></TR></TABLE>
    <P>
    <HR NOSHADE SIZE="2">
    <P>
VERBATIM
    $p = @Members;
    if ($p < 2)
    {
        print qq(    <B>$Text[2][$Lang]</B>\n);
    }
    else
    {
        if ($p == 2)
        {
            print qq(    <B>$Text[3][$Lang]</B>\n);
        }
        else
        {
            $n = $p - 1;
            $m = $Text[4][$Lang];
            $m =~ s/#/$n/;
            print qq(    <B>$m</B>\n);
        }
    }
    print <<"VERBATIM";
    <P>
    <TABLE BGCOLOR="#E0E0E0" CELLSPACING="1" CELLPADDING="7" BORDER="2">
VERBATIM
    for ( $n = 1; $n < $p; $n++ )
    {
        $m = $Members[$n];
        print <<"VERBATIM";
    <TR>
    <TD ALIGN="RIGHT" VALIGN="middle">$n</TD>
    <TD ALIGN="LEFT" VALIGN="middle">$m</TD>
    <TD ALIGN="CENTER" VALIGN="middle">
    <FORM METHOD="GET" ACTION="">
    <INPUT TYPE="hidden" NAME="l" VALUE="$Lang">
    <INPUT TYPE="hidden" NAME="p" VALUE="$n">
    <INPUT TYPE="hidden" NAME="c" VALUE="dm">
    <INPUT TYPE="hidden" NAME="t" VALUE="$Time">
    <INPUT TYPE="submit" VALUE="$Text[5][$Lang]">
    </FORM>
    </TD>
    </TR>
VERBATIM
    }
    print <<"VERBATIM";
    <TR>
    <TD COLSPAN="2" ALIGN="CENTER" VALIGN="middle">
    <FORM METHOD="GET" ACTION="">
    <INPUT TYPE="hidden" NAME="l" VALUE="$Lang">
    <INPUT TYPE="hidden" NAME="c" VALUE="am">
    <INPUT TYPE="hidden" NAME="t" VALUE="$Time">
    <INPUT TYPE="text"   NAME="p" VALUE="" SIZE="40" MAXLENGTH="80">
    </TD>
    <TD ALIGN="CENTER" VALIGN="middle">
    <INPUT TYPE="submit" VALUE="$Text[6][$Lang]">
    </FORM>
    </TD>
    </TR>
    </TABLE>
    <P>
    <HR NOSHADE SIZE="2">
    <P>
</CENTER>
</BODY>
</HTML>
VERBATIM

sub process_query_string
{
    my $query = $ENV{'QUERY_STRING'} || $ENV{'REDIRECT_QUERY_STRING'} || join('&', @ARGV) || '';
    my @pairs = split(/&/, $query);
    my($pair,$var,$val);

    foreach $pair (@pairs)
    {
        ($var,$val) = split(/=/,$pair,2);
        if ($var =~ /^[a-z]+$/i)
        {
            $val =~ s/\+/ /g;
            $val =~ s/%([0-9A-Fa-f][0-9A-Fa-f])/chr(hex($1))/eg;
            $val =~ s/#//g;
            $val =~ s/^\s+//;
            $val =~ s/\s+$//;
            $val =~ s/\s+,/,/g;
            $val =~ s/\s\s+/ /g;
            if    ($var =~ /^l(?:ang(?:uage)?)?$/i)
            {
                if (($val =~ /^\d+$/ or ($val = Decode_Language($val))) and $val >= 1 and $val <= 6) { $Lang = $val; }
            }
            elsif ($var =~ /^p(?:articipant)?$/i)
            {
                if ($val =~ /^\d+$/) { $Person = $val; } else { $Person = html($val); }
            }
            elsif ($var =~ /^c(?:md|ommand)?$/i)
            {
                if ($val =~ /^(?:am|dm)$/i) { $Command = $val; }
            }
            elsif ($var =~ /^t(?:ime(?:out)?)?$/i)
            {
                if ($val =~ /^\d+$/) { $Timeout = $val; }
            }
        }
    }
    if (($Timeout < ($Time - 120)) or
        ($Timeout >= $Time)        or
        ($Timeout < $Updated))
    {
        $Command = '';
    }
}

sub execute_command
{
    if ($Command =~ /^am$/i)
    {
        if ($Person !~ /^\.*$/)
        {
            @Members = sort ( @Members, $Person );
            $Save = 1;
        }
    }
    elsif ($Command =~ /^dm$/i)
    {
        if ($Person =~ /^\d+$/ and $Person > 0 and $Person < @Members)
        {
            splice( @Members, $Person, 1 );
            $Save = 1;
        }
    }
}

sub html
{
    my($string) = $_[0];
    my($o);
    $string =~ s/(.)/(defined $html[$o=ord($1)])?($html[$o]||"&\#$o;"):$1/eg;
    return $string;
}

sub init_tables
{
    my($i);
    $html[0x00] = '';
    $html[0x01] = '';
    $html[0x02] = '';
    $html[0x03] = '';
    $html[0x04] = '';
    $html[0x05] = '';
    $html[0x06] = '';
    $html[0x07] = '';
    $html[0x08] = '';
    # $html[0x09] = '';
    # $html[0x0A] = '';
    $html[0x0B] = '';
    $html[0x0C] = '';
    $html[0x0D] = '';
    $html[0x0E] = '';
    $html[0x0F] = '';
    $html[0x10] = '';
    $html[0x11] = '';
    $html[0x12] = '';
    $html[0x13] = '';
    $html[0x14] = '';
    $html[0x15] = '';
    $html[0x16] = '';
    $html[0x17] = '';
    $html[0x18] = '';
    $html[0x19] = '';
    $html[0x1A] = '';
    $html[0x1B] = '';
    $html[0x1C] = '';
    $html[0x1D] = '';
    $html[0x1E] = '';
    $html[0x1F] = '';
    $html[0x22] = '&quot;';
    $html[0x26] = '&amp;';
    # $html[0x27] = '&apos;';
    $html[0x3C] = '&lt;';
    $html[0x3E] = '&gt;';
    $html[0x7F] = '';
    $html[0x80] = '';
    $html[0x81] = '';
    $html[0x82] = '';
    $html[0x83] = '';
    $html[0x84] = '';
    $html[0x85] = '';
    $html[0x86] = '';
    $html[0x87] = '';
    $html[0x88] = '';
    $html[0x89] = '';
    $html[0x8A] = '';
    $html[0x8B] = '';
    $html[0x8C] = '';
    $html[0x8D] = '';
    $html[0x8E] = '';
    $html[0x8F] = '';
    $html[0x90] = '';
    $html[0x91] = '';
    $html[0x92] = '';
    $html[0x93] = '';
    $html[0x94] = '';
    $html[0x95] = '';
    $html[0x96] = '';
    $html[0x97] = '';
    $html[0x98] = '';
    $html[0x99] = '';
    $html[0x9A] = '';
    $html[0x9B] = '';
    $html[0x9C] = '';
    $html[0x9D] = '';
    $html[0x9E] = '';
    $html[0x9F] = '';
    $html[0xA0] = '&nbsp;';
    $html[0xA1] = '&iexcl;';
    $html[0xA2] = '&cent;';
    $html[0xA3] = '&pound;';
    $html[0xA4] = '&curren;';
    $html[0xA5] = '&yen;';
    $html[0xA6] = '&brvbar;';
    $html[0xA7] = '&sect;';
    $html[0xA8] = '&uml;';
    $html[0xA9] = '&copy;';
    $html[0xAA] = '&ordf;';
    $html[0xAB] = '&laquo;';
    $html[0xAC] = '&not;';
    $html[0xAD] = '&shy;';
    $html[0xAE] = '&reg;';
    $html[0xAF] = '&macr;';
    $html[0xB0] = '&deg;';
    $html[0xB1] = '&plusmn;';
    $html[0xB2] = '&sup2;';
    $html[0xB3] = '&sup3;';
    $html[0xB4] = '&acute;';
    $html[0xB5] = '&micro;';
    $html[0xB6] = '&para;';
    $html[0xB7] = '&middot;';
    $html[0xB8] = '&cedil;';
    $html[0xB9] = '&sup1;';
    $html[0xBA] = '&ordm;';
    $html[0xBB] = '&raquo;';
    $html[0xBC] = '&frac14;';
    $html[0xBD] = '&frac12;';
    $html[0xBE] = '&frac34;';
    $html[0xBF] = '&iquest;';
    $html[0xC0] = '&Agrave;';
    $html[0xC1] = '&Aacute;';
    $html[0xC2] = '&Acirc;';
    $html[0xC3] = '&Atilde;';
    $html[0xC4] = '&Auml;';
    $html[0xC5] = '&Aring;';
    $html[0xC6] = '&AElig;';
    $html[0xC7] = '&Ccedil;';
    $html[0xC8] = '&Egrave;';
    $html[0xC9] = '&Eacute;';
    $html[0xCA] = '&Ecirc;';
    $html[0xCB] = '&Euml;';
    $html[0xCC] = '&Igrave;';
    $html[0xCD] = '&Iacute;';
    $html[0xCE] = '&Icirc;';
    $html[0xCF] = '&Iuml;';
    $html[0xD0] = '&ETH;';
    $html[0xD1] = '&Ntilde;';
    $html[0xD2] = '&Ograve;';
    $html[0xD3] = '&Oacute;';
    $html[0xD4] = '&Ocirc;';
    $html[0xD5] = '&Otilde;';
    $html[0xD6] = '&Ouml;';
    $html[0xD7] = '&times;';
    $html[0xD8] = '&Oslash;';
    $html[0xD9] = '&Ugrave;';
    $html[0xDA] = '&Uacute;';
    $html[0xDB] = '&Ucirc;';
    $html[0xDC] = '&Uuml;';
    $html[0xDD] = '&Yacute;';
    $html[0xDE] = '&THORN;';
    $html[0xDF] = '&szlig;';
    $html[0xE0] = '&agrave;';
    $html[0xE1] = '&aacute;';
    $html[0xE2] = '&acirc;';
    $html[0xE3] = '&atilde;';
    $html[0xE4] = '&auml;';
    $html[0xE5] = '&aring;';
    $html[0xE6] = '&aelig;';
    $html[0xE7] = '&ccedil;';
    $html[0xE8] = '&egrave;';
    $html[0xE9] = '&eacute;';
    $html[0xEA] = '&ecirc;';
    $html[0xEB] = '&euml;';
    $html[0xEC] = '&igrave;';
    $html[0xED] = '&iacute;';
    $html[0xEE] = '&icirc;';
    $html[0xEF] = '&iuml;';
    $html[0xF0] = '&eth;';
    $html[0xF1] = '&ntilde;';
    $html[0xF2] = '&ograve;';
    $html[0xF3] = '&oacute;';
    $html[0xF4] = '&ocirc;';
    $html[0xF5] = '&otilde;';
    $html[0xF6] = '&ouml;';
    $html[0xF7] = '&divide;';
    $html[0xF8] = '&oslash;';
    $html[0xF9] = '&ugrave;';
    $html[0xFA] = '&uacute;';
    $html[0xFB] = '&ucirc;';
    $html[0xFC] = '&uuml;';
    $html[0xFD] = '&yacute;';
    $html[0xFE] = '&thorn;';
    $html[0xFF] = '&yuml;';
    for ( $i = 1; $i <= 6; $i++ ) { $lang[$i] = html(Language_to_Text($i)); }
}

__END__

